# Cover
[![Build Status](https://travis-ci.org/florence/cover.svg?branch=master)](https://travis-ci.org/florence/cover)
[![Coverage Status](https://coveralls.io/repos/florence/cover/badge.png?branch=master)](https://coveralls.io/r/florence/cover?branch=master)
[![Stories in Ready](https://badge.waffle.io/florence/cover.png?label=ready&title=Ready)](https://waffle.io/florence/cover)

This library is a supplement to rackets `raco test` that adds code coverage capabilities.

## How to install

install via `raco pkg install cover`. To install for development, checkout the repo into a folder named `cover` and in the parent directory run `raco pkg install cover/`.

## How to use

To view the arguments for Cover run `raco cover -h`.

Code coverage can be generated by specifying the `-f <format>` flag.
Right now the valid formats are: `html` and `coveralls`.

`html` simply generates html files for each source file containing coverage information and
highlighted source code.

`coveralls` generates a coveralls coverage report and sends it to coveralls.

For more detailed usage see [the full documentation](http://pkg-build.racket-lang.org/doc/cover/index.html).

## Use with TravisCI

If your code is hosted on a public github repo then you can use this plugin in conjunction with [TravisCI](https://travis-ci.org/) and [Coveralls](https://coveralls.io/).
Just enable your repository on both services and then add a `.travis.yml` file to your repo with the following contents:
```yml
langauge: c
sudo: false
env:
  global:
    - RACKET_DIR=~/racket
  matrix:
    - RACKET_VERSION=6.1.1

before_install:
  - git clone https://github.com/greghendershott/travis-racket.git ../travis-racket
  - cat ../travis-racket/install-racket.sh | bash
  - export PATH="${RACKET_DIR}/bin:${PATH}"

install: raco pkg install --deps search-auto $TRAVIS_BUILD_DIR # install dependencies

script:
 - raco test $TRAVIS_BUILD_DIR # run tests. you wrote tests, right?
 - raco cover -f coveralls -d $TRAVIS_BUILD_DIR/coverage . # generate coverage information for coveralls
```
The above Travis configuration will install any project dependencies, test your project, and report coverage information to coveralls.

For a contrived example project, look at an [example](https://github.com/rpless/rkt-ci-example).
For additional Travis configuration information look at [Travis Racket](https://github.com/greghendershott/travis-racket).

Note: This currently only works for public Github repos. This project does not support `coveralls.yml` configurations for private repos.

## Internals

Cover comes with a racket API, which can be read about in [the full documentation](http://pkg-build.racket-lang.org/doc/cover/index.html).
